//var EXPORTED_SYMBOLS = [ "GuifiProxy" ];

/**
 * GuifiProxy namespace.
 */
if ("undefined" == typeof(GuifiProxy)) var GuifiProxy = {};

//const userPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
//const userPrefExtGui = userPref.getBranch("extensions.guifiproxy.");
//const userPrefNetProx = userPref.getBranch("network.proxy.");


if ("undefined" == typeof(GuifiProxy.Utils)) {

GuifiProxy.Utils = {
  userPref : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
  userPrefExtGui : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.guifiproxy."),
  userPrefNetProx : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("network.proxy."),

  log : function(msg) {
    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
    //consoleService.logStringMessage(msg);
  },

  pstCheckPort : function(port) {
    if (!port || port.length > 60) return 0;
    port = port.replace(/ /g,"_");
    for(var x=0; x < port.length && !isNaN(port.charAt(x)); x++);
    port = port.slice(0,x);
    var cort = new String(port);
    port = Number(cort);
    port = port*1;
    if (!port || isNaN(port) || port.length > 5) return 0;
    if (port > 21 && port < 70000) return port;
    return 0;
  },

  pstCheckIfMyFormat : function(sat) {
    if(!sat[0] || !sat[1] || !sat[2] || !this.pstCheckPort(sat[2]))
      return 0;
    return 1;
  },

  pstNormInfoLine : function(line) {
    if (line.length < 11) return 0;
    line = line.replace(/\\/g,"/");
    line = line.replace(/[<>{}#\+\n\r\"\']/g,"");
    line = line.replace(/\t/g,";");
    if (line.search(/:/) < 24)
      line = line.replace(/:/,";");

    return line;
  },

  pstGetArrFromLine : function(line) {

  if((line=this.pstNormInfoLine(line)) == 0)
    return 0;

    var i,ssl;
    var sat = new Array();
    var arr = new Array();

    sat = line.split(";");
    arr = sat;
    if(sat.length < 2)
      return 0;
    //this.log("IN:\n0="+sat[0]+"\n1="+sat[1]+"\n2="+sat[2]/*+"\n3="+sat[3]+"\n4="+sat[4]+"\n5="+sat[5]*/);

    if(this.pstCheckIfMyFormat(sat))
      return sat;

    for(i=0; i < 3; i++)
      arr[i] = 0;

    arr[1] = sat[1];

    for(i=0; i < sat.length; i++) {
      if(arr[2]=this.pstCheckPort(sat[i])) {
        sat[i]=0;
          break;
      }
    }
    if(arr[2] == 0)
		return 0;

    arr[0]=sat[0];

    //arr[3]=0;

    this.log("OUT;\nIP="+arr[0]+"\nPort="+arr[1]+"\nFlag="+arr[2]);
    return arr;
  },


  pstChkProxyExist : function(ip,port) {
    var line,sat={};
    for(var i=0; this.userPrefExtGui.prefHasUserValue("server."+i); i++) {
      line = this.userPrefExtGui.getCharPref("server."+i);
      sat = line.split(";");
      if(sat[1] == ip && sat[2] == port)
        return 1;
    }
    return 0;
  },

  pstGetArrByIdx : function(idx) {
    var par = new Array();

    if(!this.userPrefExtGui.prefHasUserValue("server."+idx))	return 0;
    par = this.userPrefExtGui.getCharPref("server."+idx).split(";");
    par.push(idx);

    return par;
  }

};
}

